Unit qsgce_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure qsgce(N :Integer; N1 :Integer; var X :Array of Extended;
                var C :Array of Extended);

implementation

procedure qsgce(N :Integer; N1 :Integer; var X :Array of Extended;
                var C :Array of Extended);
var
I,J,K,N2,N3,N4,NN,NS,M,M1,M2,M3,M4,M5,M6,MM,MP :Integer;
A,C1N,CN,CN1,D,DK,DKS,FK0,FKS,P,P1,P2,Y,Y1,Y2,Y3,T,S,S1,S2,R,R0,R1,R2,
   R3,RS,RC,R3C,RN,R1N,R2N,X0,X1,X2,EPS :Extended;
H :Array [0..1499] of Extended;
AN :Array [0..29] of Extended;
BN :Array [0..29] of Extended;
DN :Array [0..29] of Extended;
const
EPS1 :Extended = 1.0e-15;
PI :Extended = 3.1415926535897932e0;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35;
begin
if ( N  >= 2  ) and ( N  <= 4 ) 
 then goto _4;
if ( N  >= 5  ) and ( N  <= 11 ) 
 then goto _1;
if ( N  >= 12  ) and ( N  <= 20 ) 
 then goto _2;
if ( N  >= 21 ) 
 then goto _3;
_1:
J := 1;
goto _17;
_2:
J := 2;
goto _17;
_3:
J := 3;
goto _17;
_4:
MM := 1;
_5:
N2 := N+1;
N3 := N div 2;
N3 := 2*N3;
if ( N  <> N3 ) 
 then goto _6;
NN := N div 2;
goto _8;
_6:
NN := (N-1) div 2;
R := 1.e0;
X[N1-1] := 0.e0;
for I:=1 to NN do
 begin
_7:
  R := R*(1.e0+1.e0/(2.e0*I-1.e0));
 end;
C[N1-1] := 2.e0*R*R/(N*N);
_8:
R := 1.e0;
for I:=1 to N2 do
 begin
  R0 := 2.e0*I;
_9:
  R := R*R0/(R0+1.e0);
 end;
A := 4.e0*R/PI;
for K:=MM to NN do
 begin
  NS := 0;
  DK := 0.e0;
  FK0 := PI*(K-0.25e0)/(N+0.5e0);
  EPS := EPS1/Sin(FK0);
  FKS := FK0;
_10:
  NS := NS+1;
  M := 1;
  RS := Sin(FKS);
  H[0] := 1.e0/(8.e0*(N+1.5e0)*RS);
_11:
  M := M+1;
  if ( M  >= 1500 ) 
   then goto _10;
  H[M-1] := H[M-2]*(M-0.5e0)*(M-0.5e0)/(2.e0*M*(N+M+0.5e0)*RS);
  if ( H[M-1]  <= EPS ) 
   then goto _12;
  if ( H[M-1]  >= H[M-2] ) 
   then goto _12;
  goto _11;
_12:
  MP := M-1;
  R1 := (N+0.5e0)*FKS-PI/4.e0;
  RC := Cos(FKS);
  T := RC/RS;
  S := 0.e0;
  S1 := 0.e0;
  for I:=1 to MP do
   begin
    R2 := N+I+0.5e0;
    R3 := R2*FKS-PI*(I+0.5e0)/2.e0;
    R3C := Cos(R3);
    S := S+H[I-1]*R3C;
_13:
    S1 := S1+H[I-1]*(R2*Sin(R3)+T*I*R3C);
   end;
  S := Cos(R1)+S;
  S1 := -(N+0.5e0)*Sin(R1)-S1;
  DKS := DK-S/S1;
  FKS := FK0+DKS;
  if ( Abs(DKS-DK)  <= EPS ) 
   then goto _14;
  DK := DKS;
  goto _10;
_14:
  X[K-1] := Cos(FKS);
  RS := Sin(FKS);
  H[0] := 1.e0/(8.e0*(N2+1.5e0)*RS);
  S2 := H[0]*Cos((N2+1.5e0)*FKS-PI*1.5e0/2.e0);
  for I:=2 to MP do
   begin
    H[I-1] := H[I-2]*(I-0.5e0)*(I-0.5e0)/(2.e0*I*(N2+I+0.5e0)*RS);
_15:
    S2 := S2+H[I-1]*Cos((N2+I+0.5e0)*FKS-PI*(I+0.5e0)/2.e0);
   end;
  S2 := Cos((N2+0.5e0)*FKS-PI/4.e0)+S2;
  R := A*N2*S2;
  D := Sin(FKS);
_16:
  C[K-1] := 4.e0*D*D*D/(R*R);
 end;
goto _35;
_17:
CN := N+0.5e0;
C1N := CN*CN;
for I:=1 to J do
 begin
  X0 := PI*(I-0.25e0);
  EPS := EPS1*C1N/X0;
  M6 := 1;
_18:
  M1 := 1;
  BN[0] := 1.e0;
  R1N := X0/2.e0;
  RN := R1N*R1N;
  M1 := M1+1;
  BN[M1-1] := RN;
_19:
  if ( BN[M1-1]  <= EPS ) 
   then goto _20;
  if ( M1  = N+1 ) 
   then goto _20;
  M2 := M1;
  M1 := M1+1;
  BN[M1-1] := RN*BN[M2-1]/(M2*M2);
  goto _19;
_20:
  M3 := 1;
  DN[M3-1] := R1N;
_21:
  M3 := M3+1;
  DN[M3-1] := RN*DN[M3-2]/((M3-1)*M3);
  if ( DN[M3-1]  <= EPS ) 
   then goto _22;
  if ( M3  = N ) 
   then goto _22;
  goto _21;
_22:
  M5 := Max0(M1,M3);
  R2N := 0.5e0/CN;
  AN[0] := 1.e0-R2N*R2N;
  for K:=2 to M5 do
   begin
    Y := (K-0.5e0)/CN;
_23:
    AN[K-1] := AN[K-2]*(1.e0-Y*Y);
   end;
  M4 := M1-1;
  for K:=1 to M4 do
   begin
_24:
    BN[K+0] := BN[K+0]*AN[K-1];
   end;
  for K:=1 to M3 do
   begin
_25:
    DN[K-1] := DN[K-1]*AN[K-1];
   end;
  P := BN[0];
  P1 := DN[0];
  N4 := -1;
  for K:=2 to M1 do
   begin
    P := P+BN[K-1]*N4;
_26:
    N4 := -N4;
   end;
  N4 := -1;
  for K:=2 to M3 do
   begin
    P1 := P1+DN[K-1]*N4;
_27:
    N4 := -N4;
   end;
  P1 := -P1;
  X1 := X0-P/P1;
  if ( Abs(X1-X0)  <= EPS ) 
   then goto _28;
  X0 := X1;
  M6 := M6+1;
  goto _18;
_28:
  X[I-1] := 1.e0-(X1*X1)/(C1N*2.e0);
  X2 := X1*(1.e0-1.e0/CN);
  CN1 := N-0.5e0;
  M1 := 1;
  BN[0] := 1.e0;
  R1N := X2/2.e0;
  RN := R1N*R1N;
  M1 := M1+1;
  BN[M1-1] := RN;
_29:
  if ( BN[M1-1]  <= EPS ) 
   then goto _30;
  if ( M1  = N ) 
   then goto _30;
  M2 := M1;
  M1 := M1+1;
  BN[M1-1] := RN*BN[M2-1]/(M2*M2);
  goto _29;
_30:
  M4 := M1-1;
  R2N := 0.5e0/CN1;
  AN[0] := 1.e0-R2N*R2N;
  for K:=2 to M4 do
   begin
    Y := (K-0.5e0)/CN1;
_31:
    AN[K-1] := AN[K-2]*(1.e0-Y*Y);
   end;
  for K:=1 to M4 do
   begin
_32:
    BN[K+0] := BN[K+0]*AN[K-1];
   end;
  P2 := BN[0];
  N4 := -1;
  for K:=2 to M1 do
   begin
    P2 := P2+BN[K-1]*N4;
_33:
    N4 := -N4;
   end;
  Y1 := N*P2;
  Y3 := X1/CN;
  Y2 := Y3*Y3;
_34:
  C[I-1] := 2.e0*Y2*(1.e0-Y2/4.e0)/(Y1*Y1);
 end;
MM := J+1;
goto _5;
_35:
end;

end.
